function build_ff_matrix(code,lead_number)
%-------------------------------------------------------------------------------------------------------------
%This program builds a matrix for batch training--------------------------------------------------------------

%disp('Enter the directory you want to access ("OCD", "Controls", "Schizo" e.t.c.)');
%code = input('There must exist an appropriately named file (i.e.: OCD_data.mat file):   ','s');
%node_number = input('Which electrode should be examined? (2-16):   ');
%disp('Enter the number of input delays for the network');
%delays_number = input('not including delay "0":   ');
%how many instances of the signal to be used---
st_in = 11;
fin_in = 41;
st_out = 39;
fin_out = 81;
Type = 'LOW';
%----------------------------------------------
if (strcmp(code,'Controls') == 1)
    yy = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19};
elseif (strcmp(code,'OCD') == 1)
    yy = {1,2,3,4,5,6,10,11,12,13,14,15,16,17,18};
else
    error('No such category');
end
%----------------------------------------------

%manipulate strings and opening the appropriate *.mat file-------
S1 = ['C:\Matlab\work\' Type '\' code];
cd (S1);
S2 = [code '_data'];
load(S2);
%----------------------------------------------------------------

%-----------------------------------------
%convert electrode number to string--    
str2 = int2str(lead_number);
%------------------------------------
%name of file in which net is to be saved and loaded--------
sav = [code '_electr' str2];
%-----------------------------------------------------------
%subdirectory name------------------------------------------
SX = [S1 '\NN-ff'];
S2 = ['C:\Matlab\work\' Type '\' code '\NN-ff\' sav];
%-----------------------------------------------------------
%make appropriate directory if it doesn't exist--------------------
try
    cd (S2);
catch
    try
        cd (SX);
    catch
        mkdir(S1,'\NN-ff');
        cd(SX);
    end
    mkdir(SX, sav);
    cd (S2);
end
clear temp,SX;
%-------------------------------------------------------------------

%keep in memory, only the data for the appropriate node-------------
tem = length(yy);
for i=1:tem
    temk(i) = yy{i};
end;
sizstr = int2str(tem);
NAMP(:,:) = AMP(lead_number-1,:,temk);
clear AMP temk;
%-------------------------------------------------------------------

%build the appropriate matrix which has tem columnes --------------------------------------------------------------
lin = fin_in - st_in +1;
matrix_end = lin + fin_out-st_out+1;
for k=1:tem
        MATRIX(1:lin,k) = NAMP(st_in:fin_in,k);
        MATRIX(lin+1:matrix_end,k) = NAMP(st_out:fin_out,k);
end
clear NAMP k j S2 tempcol kstr tstr sizstr;
%-------------------------------------------------------------------------------------------------------------------
%preprocessing the matrix------------------------------------------------------------
MATRIX = transpose(MATRIX);
minM(1:tem) = min(min(MATRIX));
maxM(1:tem) = max(max(MATRIX));
maxM = maxM';
minM = minM';
MATRIX = tramnmx(MATRIX,minM,maxM);
MATRIX = transpose(MATRIX);
minM = minM(1);
maxM = maxM(1);
%------------------------------------------------------------------------------------
st_instr = int2str(st_in);
fin_instr = int2str(fin_in);
st_outstr = int2str(st_out);
fin_outstr = int2str(fin_out);
temp = ['ff_matrix(' st_instr '-' fin_instr ')(' st_outstr '-' fin_outstr ')'];
save (temp,'MATRIX','maxM','minM');
%----------------------------------------------------