function ff_predict(code,node_number)
%-------------------------------------------------------------------------------------------------------------
%This program predicts amplitudes for a subject---------------------------------------------------------------
clc;
%how many instances of the signal to be used---
st_in = 71;
fin_in = 126;
out_str = 'P300+50';
Type = 'LOW';
peak_type = 1 %1 or 2
hid1 = 50;
hid2 = 30;
hid3 = 0;
%-------------build string---------------------
strhid1 = int2str(hid1);
strhid2 = int2str(hid2);
st_instr = int2str(st_in);
fin_instr = int2str(fin_in);
if hid3 == 0
    newtmpstr = [strhid1 '-' strhid2 '('st_instr '-' fin_instr ')' out_str];
else
    strhid3 = int2str(hid3);
    newtmpstr = [strhid1 '-' strhid2 '-' strhid3 '('st_instr '-' fin_instr ')' out_str];
end
%----------------------------------------------
if (strcmp(code,'Controls') == 1)
    yy = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19};
elseif (strcmp(code,'OCD') == 1)
    yy = {1,2,3,4,5,6,10,11,12,13,14,15,16,17,18};
else
    error('No such category');
end
num = length(yy);
categ = {'Controls', 'OCD'};
%----------------------------------------------
%manipulate strings and opening the appropriate *.mat file-------
S1 = ['C:\Matlab\work\' Type '\' code];
cd (S1);
S2 = [code '_data'];
load(S2);
%----------------------------------------------------------------
numstr = int2str(num);
global siz;
if (isempty(siz)==1)
    clear global siz;
    siz = 0;
    while (siz > num | siz < 1)
        clc;
        tmtx = ['There are ' numstr ' different trained networks'];
        disp(tmtx);
        tmtx = ['Press 1-' numstr ' to select a subject and predict'];
        disp(tmtx);
        siz = input('the performance with the only net that is not trained for the data:   ');
    end
end
clear siztmp tmtx numstr;
sizstr = int2str(siz);
%---------------------
inp = fin_in - st_in + 1;
TEMPIN(1:inp) = AMP(node_number-1,st_in:fin_in,yy{siz});
TEMPOUT = AMP(node_number-1,st_out:fin_out,yy{siz});
clear AMP;
%build plot label-------
tmp = int2str(siz);
S3 = [code ' ' tmp];
clear tmp siz;
%-----------------------------------------
%convert electrode number to string--    
str2 = int2str(node_number);
%------------------------------------
%setting time----------------------------------
t1 = (st_in*2):2:(2*fin_in);
time = (st_out*2):2:(2*fin_out);
%----------------------------------------------


for j=1:length(categ)
%name of directory from which the trained net is to be loaded--------
sav = [categ{j} '_electr' str2];
%--------------------------------------------------------------------
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\' Type '\' categ{j} '\NN-ff\' sav '\' newtmpstr];
%-----------------------------------------------------------
%load the appropriate network or return error-------------------------------------------
try
    cd(S2);
    if strcmp(code,categ{j}) == 1
        temp = [S2 '\hipp_net(' st_instr '-' fin_instr ')' out_str 'ex' sizstr '.mat'];
    else
        temp = [S2 '\hipp_net(' st_instr '-' fin_instr ')' out_str 'ex1.mat'];
    end
    load (temp);
    clear temp;
    P = tramnmx(TEMPIN,minM,maxM);
    P=P';
catch
    disp('Error in loading trained batch network for predicting');
    error('Enter the appropriate time parameters or train a net with function batch_train');
end
%--------------------------------------------------------------------------------------
%plotting phase 1--------------------------------------------------------------
S3_IN=[S3 ' input'];
S3_OUT=[S3 ' output'];
plot(t1,TEMPIN,'-m');
hold on;
plot(time,TEMPOUT,'-g');
legend(S3_IN,S3_OUT,4);
axis([0 1022 -30 30]);
xlabel('Time');
ylabel('Amplitude');
stitle=['Lead ' str2];
title(stitle);
%----------------------------------------------
disp('------------------------------------------------------------------------------------------------------');
disp('Press a key to continue');
%----------------------------------------------
plot([0 1022],[0 0],'k');
legend(S3_IN,S3_OUT,'zero',4);
%end plotting phase 1----------------------------------------------------------

%NET adapt and plotting----------------------------------------------------------
%initializing output, error and time
SUM=0;
%-----------------------------------
[T] = sim(net,P);
%postprocessing for accurate plotting
TX = postmnmx(T,minM,maxM);
%------------------------------------
%indirect calculation of the error for displaying
output = fin_out-st_out+1;
for i=1:output
    ERR(i) = TX(i) - TEMPOUT(i);
    SUM = SUM + ERR(i)*ERR(i);
end
%---------------------
%plot error and output
plot(time,TX,'b',time,ERR,'r');
%---------------------
%legend-----------------------------------
legend(S3_IN,S3_OUT,'zero','Prediction','Error',4);
%-----------------------------------------
drawnow;
%calculating and displaying MSE---------
MErr = SUM/output;
strMSE = num2str(MErr,5);
dstr = ['MSE=' strMSE];
text(20,20,dstr);
dstr = [categ{j} ' ex' sizstr ' perf:'];
text(20,17,dstr);
strperf = num2str(perf);
text(50,15,strperf);
hold off;
%---------------------------------------
sav = [code '_electr' str2];
S2 = ['C:\Matlab\work\' Type '\' code '\NN-ff\' sav '\' newtmpstr];
cd (S2);
tmstr = [S3 '-' categ{j}];
print('-f1','-dbmp','-r100', tmstr);
clear minM maxM;
end