function ff_train(code,lead_number)
%-------------------------------------------------------------------------------------------------------------
%This program trains a network to simulate the Amplitudes of a subject category-------------------------------
%how many instances of the signal to be used---
st_in = 71;
fin_in = 126;
out_str = 'P300+50';
Type = 'LOW';
hid1 = 30;
hid2 = 30;
hid3 = 0;
%----------------------------------------------
clc;
global cnt
%----------------------------------------------
output = fin_out - st_out + 1;
%----------------------------------------
%convert electrode number to string--
str2 = int2str(lead_number);
%------------------------------------
%name of file in which net is to be saved and loaded--------
sav = [code '_electr' str2];
%-----------------------------------------------------------
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\' Type '\' code '\NN-ff\' sav];
%-----------------------------------------------------------
%load the appropriate matrix or return error-------------------------------------------
try
    cd(S2);
    st_instr = int2str(st_in);
    fin_instr = int2str(fin_in);
    st_outstr = int2str(st_out);
    fin_outstr = int2str(fin_out);
    temp = [S2 '\ff_matrix(' st_instr '-' fin_instr ')(' st_outstr '-' fin_outstr ')'];
    load (temp);
    num = size(MATRIX,2);
    %----------------------------------------------------------
    if (isempty(cnt)==1)
        clear global cnt;
        cnt = 0;
        while (cnt < 1) | (cnt > num)
            numstr = int2str(num);
            tmp = ['Leave out which subject? (1-' numstr '):   '];
            cnt = input(tmp);
        end
    end
    clear tmp numstr;
    %-----------------------------------------------------------
    col = size(MATRIX,2);
    lin = size(MATRIX,1);
    if (cnt > 1 & cnt < num)
        TEMP(:,1:cnt-1) = MATRIX(:,1:cnt-1);
        TEMP(:,cnt:col-1) = MATRIX(:,cnt+1:col);
    elseif (cnt == 1)
        TEMP = MATRIX(:,2:col);
    else
        TEMP = MATRIX(:,1:col-1);
    end
    clear MATRIX;
    col = col-1;     %length of new matrix
    trainsize = col-4;
    validsize = 4;
    mid_size = fin_in - st_in + 1;
    %radefining the columns of MATRIX----------------------------------------------------
    for i=1:trainsize
        MATRIX(:,i) = TEMP(:,i);
    end
    %------------------------------------------------------------------------------------
    for i=1:validsize
        VALID(:,i) = TEMP(:,trainsize+i);
    end
    clear TEMP temp perm;
catch
    disp('Error in loading data matrix for batch training');
    error('Execute function make_batch_matrix with the appropriate parameters');
end
%--------------------------------------------------------------------------------------

%training the network-----------------------------------------
p{1}=MATRIX(1:mid_size,:);
t{1}=MATRIX(mid_size+1:lin,:);
VV.P{1} = VALID(1:mid_size,:);
VV.T{1} = VALID(mid_size+1:lin,:);
clear MATRIX VALID;

disp('Network building and training');
disp('----------------------------------------------------------------------------------------------------------------------------');
%defining the network----------------------
cntstr = int2str(cnt);
str = ['ff_net(' st_instr '-' fin_instr ')(' st_outstr '-' fin_outstr ')ex' cntstr '.mat'];
strpic = ['train_perf(' st_instr '-' fin_instr ')(' st_outstr '-' fin_outstr ')ex' cntstr];
strx2 = [S2 '\' str];
temp = exist (strx2);
for i=1:mid_size
    PR(i,1) =-1;
    PR(i,2) = 1;
end
if temp ~= 0
    load (str);
    net.trainParam.minstep = 1e-08;
    net.trainParam.goal = 0;
    net.trainParam.epochs = 2;
    epotmp = epo;
else
    if hid3 == 0
        net = newff(PR,[hid1 hid2 output],{'tansig' 'tansig' 'tansig'},'trainlm');
    else
        net = newff(PR,[hid1 hid2 hid3 output],{'tansig' 'tansig' 'tansig' 'tansig'},'trainlm');
    end
    net.trainParam.goal = 0;
    net.trainParam.mem_reduc = 1;
    net.trainParam.lr = 0.1;
    net.trainParam.epochs = 100;
    net.trainParam.show = 1;
    net.trainParam.minstep = 1e-20;
    epotmp = 0;
end
clear temp;
%------------------------------------------
strhid1 = int2str(hid1);
strhid2 = int2str(hid2);
if hid3 == 0
    newtmpstr = [strhid1 '-' strhid2 '('st_instr '-' fin_instr ')(' st_outstr '-' fin_outstr ')'];
else
    strhid3 = int2str(hid3);
    newtmpstr = [strhid1 '-' strhid2 '-' strhid3 '('st_instr '-' fin_instr ')(' st_outstr '-' fin_outstr ')'];
end
try
    cd (newtmpstr);
catch
    mkdir(S2,newtmpstr);
    cd (newtmpstr);
end
    [net,tr] = train(net,p,t,[],[],VV);
    epo = tr.epoch(end) + epotmp;
    perf = tr.perf(end);
    save (str,'net','maxM','minM','epo','perf');
    print('-dbmp', '-r80', strpic);
%    dos ('C:\Progra~1\winamp\winamp.exe/ E:\Songs\Napster_Songs\test.M3U');
%    dos ('C:\Progra~1\12Ghosts\12Shut~1.exe');
%------------------------------------------
%--------------------------------------------------------------